# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['DecryptionRuleArgs', 'DecryptionRule']

@pulumi.input_type
class DecryptionRuleArgs:
    def __init__(__self__, *,
                 action: pulumi.Input[str],
                 categories: pulumi.Input[Sequence[pulumi.Input[str]]],
                 destinations: pulumi.Input[Sequence[pulumi.Input[str]]],
                 froms: pulumi.Input[Sequence[pulumi.Input[str]]],
                 services: pulumi.Input[Sequence[pulumi.Input[str]]],
                 source_users: pulumi.Input[Sequence[pulumi.Input[str]]],
                 sources: pulumi.Input[Sequence[pulumi.Input[str]]],
                 tos: pulumi.Input[Sequence[pulumi.Input[str]]],
                 description: Optional[pulumi.Input[str]] = None,
                 destination_hips: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 disabled: Optional[pulumi.Input[bool]] = None,
                 folder: Optional[pulumi.Input[str]] = None,
                 log_fail: Optional[pulumi.Input[bool]] = None,
                 log_setting: Optional[pulumi.Input[str]] = None,
                 log_success: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 negate_destination: Optional[pulumi.Input[bool]] = None,
                 negate_source: Optional[pulumi.Input[bool]] = None,
                 position: Optional[pulumi.Input[str]] = None,
                 profile: Optional[pulumi.Input[str]] = None,
                 snippet: Optional[pulumi.Input[str]] = None,
                 source_hips: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 type: Optional[pulumi.Input['DecryptionRuleTypeArgs']] = None):
        """
        The set of arguments for constructing a DecryptionRule resource.
        :param pulumi.Input[str] action: The Action param. String must be one of these: `"decrypt"`, `"no-decrypt"`.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] categories: The Categories param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] destinations: The Destinations param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] froms: The Froms param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] services: The Services param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] source_users: The SourceUsers param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] sources: The Sources param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] tos: The Tos param.
        :param pulumi.Input[str] description: The Description param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] destination_hips: The DestinationHips param.
        :param pulumi.Input[str] device: The Device param.
        :param pulumi.Input[bool] disabled: The Disabled param.
        :param pulumi.Input[str] folder: The Folder param.
        :param pulumi.Input[bool] log_fail: The LogFail param.
        :param pulumi.Input[str] log_setting: The LogSetting param.
        :param pulumi.Input[bool] log_success: The LogSuccess param.
        :param pulumi.Input[str] name: The Name param.
        :param pulumi.Input[bool] negate_destination: The NegateDestination param.
        :param pulumi.Input[bool] negate_source: The NegateSource param.
        :param pulumi.Input[str] position: The Position param. String must be one of these: `"pre"`, `"post"`. Default: `"pre"`.
        :param pulumi.Input[str] profile: The Profile param.
        :param pulumi.Input[str] snippet: The Snippet param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] source_hips: The SourceHips param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] tags: The Tags param.
        :param pulumi.Input['DecryptionRuleTypeArgs'] type: The Type param.
        """
        pulumi.set(__self__, "action", action)
        pulumi.set(__self__, "categories", categories)
        pulumi.set(__self__, "destinations", destinations)
        pulumi.set(__self__, "froms", froms)
        pulumi.set(__self__, "services", services)
        pulumi.set(__self__, "source_users", source_users)
        pulumi.set(__self__, "sources", sources)
        pulumi.set(__self__, "tos", tos)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if destination_hips is not None:
            pulumi.set(__self__, "destination_hips", destination_hips)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if disabled is not None:
            pulumi.set(__self__, "disabled", disabled)
        if folder is not None:
            pulumi.set(__self__, "folder", folder)
        if log_fail is not None:
            pulumi.set(__self__, "log_fail", log_fail)
        if log_setting is not None:
            pulumi.set(__self__, "log_setting", log_setting)
        if log_success is not None:
            pulumi.set(__self__, "log_success", log_success)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if negate_destination is not None:
            pulumi.set(__self__, "negate_destination", negate_destination)
        if negate_source is not None:
            pulumi.set(__self__, "negate_source", negate_source)
        if position is not None:
            pulumi.set(__self__, "position", position)
        if profile is not None:
            pulumi.set(__self__, "profile", profile)
        if snippet is not None:
            pulumi.set(__self__, "snippet", snippet)
        if source_hips is not None:
            pulumi.set(__self__, "source_hips", source_hips)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def action(self) -> pulumi.Input[str]:
        """
        The Action param. String must be one of these: `"decrypt"`, `"no-decrypt"`.
        """
        return pulumi.get(self, "action")

    @action.setter
    def action(self, value: pulumi.Input[str]):
        pulumi.set(self, "action", value)

    @property
    @pulumi.getter
    def categories(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        The Categories param.
        """
        return pulumi.get(self, "categories")

    @categories.setter
    def categories(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "categories", value)

    @property
    @pulumi.getter
    def destinations(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        The Destinations param.
        """
        return pulumi.get(self, "destinations")

    @destinations.setter
    def destinations(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "destinations", value)

    @property
    @pulumi.getter
    def froms(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        The Froms param.
        """
        return pulumi.get(self, "froms")

    @froms.setter
    def froms(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "froms", value)

    @property
    @pulumi.getter
    def services(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        The Services param.
        """
        return pulumi.get(self, "services")

    @services.setter
    def services(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "services", value)

    @property
    @pulumi.getter(name="sourceUsers")
    def source_users(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        The SourceUsers param.
        """
        return pulumi.get(self, "source_users")

    @source_users.setter
    def source_users(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "source_users", value)

    @property
    @pulumi.getter
    def sources(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        The Sources param.
        """
        return pulumi.get(self, "sources")

    @sources.setter
    def sources(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "sources", value)

    @property
    @pulumi.getter
    def tos(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        The Tos param.
        """
        return pulumi.get(self, "tos")

    @tos.setter
    def tos(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "tos", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        The Description param.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="destinationHips")
    def destination_hips(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The DestinationHips param.
        """
        return pulumi.get(self, "destination_hips")

    @destination_hips.setter
    def destination_hips(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "destination_hips", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        The Device param.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter
    def disabled(self) -> Optional[pulumi.Input[bool]]:
        """
        The Disabled param.
        """
        return pulumi.get(self, "disabled")

    @disabled.setter
    def disabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "disabled", value)

    @property
    @pulumi.getter
    def folder(self) -> Optional[pulumi.Input[str]]:
        """
        The Folder param.
        """
        return pulumi.get(self, "folder")

    @folder.setter
    def folder(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "folder", value)

    @property
    @pulumi.getter(name="logFail")
    def log_fail(self) -> Optional[pulumi.Input[bool]]:
        """
        The LogFail param.
        """
        return pulumi.get(self, "log_fail")

    @log_fail.setter
    def log_fail(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "log_fail", value)

    @property
    @pulumi.getter(name="logSetting")
    def log_setting(self) -> Optional[pulumi.Input[str]]:
        """
        The LogSetting param.
        """
        return pulumi.get(self, "log_setting")

    @log_setting.setter
    def log_setting(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "log_setting", value)

    @property
    @pulumi.getter(name="logSuccess")
    def log_success(self) -> Optional[pulumi.Input[bool]]:
        """
        The LogSuccess param.
        """
        return pulumi.get(self, "log_success")

    @log_success.setter
    def log_success(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "log_success", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The Name param.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="negateDestination")
    def negate_destination(self) -> Optional[pulumi.Input[bool]]:
        """
        The NegateDestination param.
        """
        return pulumi.get(self, "negate_destination")

    @negate_destination.setter
    def negate_destination(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "negate_destination", value)

    @property
    @pulumi.getter(name="negateSource")
    def negate_source(self) -> Optional[pulumi.Input[bool]]:
        """
        The NegateSource param.
        """
        return pulumi.get(self, "negate_source")

    @negate_source.setter
    def negate_source(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "negate_source", value)

    @property
    @pulumi.getter
    def position(self) -> Optional[pulumi.Input[str]]:
        """
        The Position param. String must be one of these: `"pre"`, `"post"`. Default: `"pre"`.
        """
        return pulumi.get(self, "position")

    @position.setter
    def position(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "position", value)

    @property
    @pulumi.getter
    def profile(self) -> Optional[pulumi.Input[str]]:
        """
        The Profile param.
        """
        return pulumi.get(self, "profile")

    @profile.setter
    def profile(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "profile", value)

    @property
    @pulumi.getter
    def snippet(self) -> Optional[pulumi.Input[str]]:
        """
        The Snippet param.
        """
        return pulumi.get(self, "snippet")

    @snippet.setter
    def snippet(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "snippet", value)

    @property
    @pulumi.getter(name="sourceHips")
    def source_hips(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The SourceHips param.
        """
        return pulumi.get(self, "source_hips")

    @source_hips.setter
    def source_hips(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "source_hips", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The Tags param.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input['DecryptionRuleTypeArgs']]:
        """
        The Type param.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input['DecryptionRuleTypeArgs']]):
        pulumi.set(self, "type", value)


@pulumi.input_type
class _DecryptionRuleState:
    def __init__(__self__, *,
                 action: Optional[pulumi.Input[str]] = None,
                 categories: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 destination_hips: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 destinations: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 disabled: Optional[pulumi.Input[bool]] = None,
                 folder: Optional[pulumi.Input[str]] = None,
                 froms: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 log_fail: Optional[pulumi.Input[bool]] = None,
                 log_setting: Optional[pulumi.Input[str]] = None,
                 log_success: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 negate_destination: Optional[pulumi.Input[bool]] = None,
                 negate_source: Optional[pulumi.Input[bool]] = None,
                 position: Optional[pulumi.Input[str]] = None,
                 profile: Optional[pulumi.Input[str]] = None,
                 services: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 snippet: Optional[pulumi.Input[str]] = None,
                 source_hips: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 source_users: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 sources: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 tfid: Optional[pulumi.Input[str]] = None,
                 tos: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 type: Optional[pulumi.Input['DecryptionRuleTypeArgs']] = None):
        """
        Input properties used for looking up and filtering DecryptionRule resources.
        :param pulumi.Input[str] action: The Action param. String must be one of these: `"decrypt"`, `"no-decrypt"`.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] categories: The Categories param.
        :param pulumi.Input[str] description: The Description param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] destination_hips: The DestinationHips param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] destinations: The Destinations param.
        :param pulumi.Input[str] device: The Device param.
        :param pulumi.Input[bool] disabled: The Disabled param.
        :param pulumi.Input[str] folder: The Folder param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] froms: The Froms param.
        :param pulumi.Input[bool] log_fail: The LogFail param.
        :param pulumi.Input[str] log_setting: The LogSetting param.
        :param pulumi.Input[bool] log_success: The LogSuccess param.
        :param pulumi.Input[str] name: The Name param.
        :param pulumi.Input[bool] negate_destination: The NegateDestination param.
        :param pulumi.Input[bool] negate_source: The NegateSource param.
        :param pulumi.Input[str] position: The Position param. String must be one of these: `"pre"`, `"post"`. Default: `"pre"`.
        :param pulumi.Input[str] profile: The Profile param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] services: The Services param.
        :param pulumi.Input[str] snippet: The Snippet param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] source_hips: The SourceHips param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] source_users: The SourceUsers param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] sources: The Sources param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] tags: The Tags param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] tos: The Tos param.
        :param pulumi.Input['DecryptionRuleTypeArgs'] type: The Type param.
        """
        if action is not None:
            pulumi.set(__self__, "action", action)
        if categories is not None:
            pulumi.set(__self__, "categories", categories)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if destination_hips is not None:
            pulumi.set(__self__, "destination_hips", destination_hips)
        if destinations is not None:
            pulumi.set(__self__, "destinations", destinations)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if disabled is not None:
            pulumi.set(__self__, "disabled", disabled)
        if folder is not None:
            pulumi.set(__self__, "folder", folder)
        if froms is not None:
            pulumi.set(__self__, "froms", froms)
        if log_fail is not None:
            pulumi.set(__self__, "log_fail", log_fail)
        if log_setting is not None:
            pulumi.set(__self__, "log_setting", log_setting)
        if log_success is not None:
            pulumi.set(__self__, "log_success", log_success)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if negate_destination is not None:
            pulumi.set(__self__, "negate_destination", negate_destination)
        if negate_source is not None:
            pulumi.set(__self__, "negate_source", negate_source)
        if position is not None:
            pulumi.set(__self__, "position", position)
        if profile is not None:
            pulumi.set(__self__, "profile", profile)
        if services is not None:
            pulumi.set(__self__, "services", services)
        if snippet is not None:
            pulumi.set(__self__, "snippet", snippet)
        if source_hips is not None:
            pulumi.set(__self__, "source_hips", source_hips)
        if source_users is not None:
            pulumi.set(__self__, "source_users", source_users)
        if sources is not None:
            pulumi.set(__self__, "sources", sources)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if tfid is not None:
            pulumi.set(__self__, "tfid", tfid)
        if tos is not None:
            pulumi.set(__self__, "tos", tos)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def action(self) -> Optional[pulumi.Input[str]]:
        """
        The Action param. String must be one of these: `"decrypt"`, `"no-decrypt"`.
        """
        return pulumi.get(self, "action")

    @action.setter
    def action(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "action", value)

    @property
    @pulumi.getter
    def categories(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The Categories param.
        """
        return pulumi.get(self, "categories")

    @categories.setter
    def categories(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "categories", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        The Description param.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="destinationHips")
    def destination_hips(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The DestinationHips param.
        """
        return pulumi.get(self, "destination_hips")

    @destination_hips.setter
    def destination_hips(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "destination_hips", value)

    @property
    @pulumi.getter
    def destinations(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The Destinations param.
        """
        return pulumi.get(self, "destinations")

    @destinations.setter
    def destinations(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "destinations", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        The Device param.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter
    def disabled(self) -> Optional[pulumi.Input[bool]]:
        """
        The Disabled param.
        """
        return pulumi.get(self, "disabled")

    @disabled.setter
    def disabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "disabled", value)

    @property
    @pulumi.getter
    def folder(self) -> Optional[pulumi.Input[str]]:
        """
        The Folder param.
        """
        return pulumi.get(self, "folder")

    @folder.setter
    def folder(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "folder", value)

    @property
    @pulumi.getter
    def froms(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The Froms param.
        """
        return pulumi.get(self, "froms")

    @froms.setter
    def froms(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "froms", value)

    @property
    @pulumi.getter(name="logFail")
    def log_fail(self) -> Optional[pulumi.Input[bool]]:
        """
        The LogFail param.
        """
        return pulumi.get(self, "log_fail")

    @log_fail.setter
    def log_fail(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "log_fail", value)

    @property
    @pulumi.getter(name="logSetting")
    def log_setting(self) -> Optional[pulumi.Input[str]]:
        """
        The LogSetting param.
        """
        return pulumi.get(self, "log_setting")

    @log_setting.setter
    def log_setting(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "log_setting", value)

    @property
    @pulumi.getter(name="logSuccess")
    def log_success(self) -> Optional[pulumi.Input[bool]]:
        """
        The LogSuccess param.
        """
        return pulumi.get(self, "log_success")

    @log_success.setter
    def log_success(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "log_success", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The Name param.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="negateDestination")
    def negate_destination(self) -> Optional[pulumi.Input[bool]]:
        """
        The NegateDestination param.
        """
        return pulumi.get(self, "negate_destination")

    @negate_destination.setter
    def negate_destination(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "negate_destination", value)

    @property
    @pulumi.getter(name="negateSource")
    def negate_source(self) -> Optional[pulumi.Input[bool]]:
        """
        The NegateSource param.
        """
        return pulumi.get(self, "negate_source")

    @negate_source.setter
    def negate_source(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "negate_source", value)

    @property
    @pulumi.getter
    def position(self) -> Optional[pulumi.Input[str]]:
        """
        The Position param. String must be one of these: `"pre"`, `"post"`. Default: `"pre"`.
        """
        return pulumi.get(self, "position")

    @position.setter
    def position(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "position", value)

    @property
    @pulumi.getter
    def profile(self) -> Optional[pulumi.Input[str]]:
        """
        The Profile param.
        """
        return pulumi.get(self, "profile")

    @profile.setter
    def profile(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "profile", value)

    @property
    @pulumi.getter
    def services(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The Services param.
        """
        return pulumi.get(self, "services")

    @services.setter
    def services(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "services", value)

    @property
    @pulumi.getter
    def snippet(self) -> Optional[pulumi.Input[str]]:
        """
        The Snippet param.
        """
        return pulumi.get(self, "snippet")

    @snippet.setter
    def snippet(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "snippet", value)

    @property
    @pulumi.getter(name="sourceHips")
    def source_hips(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The SourceHips param.
        """
        return pulumi.get(self, "source_hips")

    @source_hips.setter
    def source_hips(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "source_hips", value)

    @property
    @pulumi.getter(name="sourceUsers")
    def source_users(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The SourceUsers param.
        """
        return pulumi.get(self, "source_users")

    @source_users.setter
    def source_users(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "source_users", value)

    @property
    @pulumi.getter
    def sources(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The Sources param.
        """
        return pulumi.get(self, "sources")

    @sources.setter
    def sources(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "sources", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The Tags param.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter
    def tfid(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "tfid")

    @tfid.setter
    def tfid(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "tfid", value)

    @property
    @pulumi.getter
    def tos(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The Tos param.
        """
        return pulumi.get(self, "tos")

    @tos.setter
    def tos(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "tos", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input['DecryptionRuleTypeArgs']]:
        """
        The Type param.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input['DecryptionRuleTypeArgs']]):
        pulumi.set(self, "type", value)


class DecryptionRule(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 action: Optional[pulumi.Input[str]] = None,
                 categories: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 destination_hips: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 destinations: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 disabled: Optional[pulumi.Input[bool]] = None,
                 folder: Optional[pulumi.Input[str]] = None,
                 froms: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 log_fail: Optional[pulumi.Input[bool]] = None,
                 log_setting: Optional[pulumi.Input[str]] = None,
                 log_success: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 negate_destination: Optional[pulumi.Input[bool]] = None,
                 negate_source: Optional[pulumi.Input[bool]] = None,
                 position: Optional[pulumi.Input[str]] = None,
                 profile: Optional[pulumi.Input[str]] = None,
                 services: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 snippet: Optional[pulumi.Input[str]] = None,
                 source_hips: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 source_users: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 sources: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 tos: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 type: Optional[pulumi.Input[pulumi.InputType['DecryptionRuleTypeArgs']]] = None,
                 __props__=None):
        """
        Retrieves a config item.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_scm as scm

        example = scm.DecryptionRule("example")
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] action: The Action param. String must be one of these: `"decrypt"`, `"no-decrypt"`.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] categories: The Categories param.
        :param pulumi.Input[str] description: The Description param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] destination_hips: The DestinationHips param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] destinations: The Destinations param.
        :param pulumi.Input[str] device: The Device param.
        :param pulumi.Input[bool] disabled: The Disabled param.
        :param pulumi.Input[str] folder: The Folder param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] froms: The Froms param.
        :param pulumi.Input[bool] log_fail: The LogFail param.
        :param pulumi.Input[str] log_setting: The LogSetting param.
        :param pulumi.Input[bool] log_success: The LogSuccess param.
        :param pulumi.Input[str] name: The Name param.
        :param pulumi.Input[bool] negate_destination: The NegateDestination param.
        :param pulumi.Input[bool] negate_source: The NegateSource param.
        :param pulumi.Input[str] position: The Position param. String must be one of these: `"pre"`, `"post"`. Default: `"pre"`.
        :param pulumi.Input[str] profile: The Profile param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] services: The Services param.
        :param pulumi.Input[str] snippet: The Snippet param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] source_hips: The SourceHips param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] source_users: The SourceUsers param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] sources: The Sources param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] tags: The Tags param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] tos: The Tos param.
        :param pulumi.Input[pulumi.InputType['DecryptionRuleTypeArgs']] type: The Type param.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DecryptionRuleArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Retrieves a config item.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_scm as scm

        example = scm.DecryptionRule("example")
        ```

        :param str resource_name: The name of the resource.
        :param DecryptionRuleArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DecryptionRuleArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 action: Optional[pulumi.Input[str]] = None,
                 categories: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 destination_hips: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 destinations: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 disabled: Optional[pulumi.Input[bool]] = None,
                 folder: Optional[pulumi.Input[str]] = None,
                 froms: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 log_fail: Optional[pulumi.Input[bool]] = None,
                 log_setting: Optional[pulumi.Input[str]] = None,
                 log_success: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 negate_destination: Optional[pulumi.Input[bool]] = None,
                 negate_source: Optional[pulumi.Input[bool]] = None,
                 position: Optional[pulumi.Input[str]] = None,
                 profile: Optional[pulumi.Input[str]] = None,
                 services: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 snippet: Optional[pulumi.Input[str]] = None,
                 source_hips: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 source_users: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 sources: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 tos: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 type: Optional[pulumi.Input[pulumi.InputType['DecryptionRuleTypeArgs']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DecryptionRuleArgs.__new__(DecryptionRuleArgs)

            if action is None and not opts.urn:
                raise TypeError("Missing required property 'action'")
            __props__.__dict__["action"] = action
            if categories is None and not opts.urn:
                raise TypeError("Missing required property 'categories'")
            __props__.__dict__["categories"] = categories
            __props__.__dict__["description"] = description
            __props__.__dict__["destination_hips"] = destination_hips
            if destinations is None and not opts.urn:
                raise TypeError("Missing required property 'destinations'")
            __props__.__dict__["destinations"] = destinations
            __props__.__dict__["device"] = device
            __props__.__dict__["disabled"] = disabled
            __props__.__dict__["folder"] = folder
            if froms is None and not opts.urn:
                raise TypeError("Missing required property 'froms'")
            __props__.__dict__["froms"] = froms
            __props__.__dict__["log_fail"] = log_fail
            __props__.__dict__["log_setting"] = log_setting
            __props__.__dict__["log_success"] = log_success
            __props__.__dict__["name"] = name
            __props__.__dict__["negate_destination"] = negate_destination
            __props__.__dict__["negate_source"] = negate_source
            __props__.__dict__["position"] = position
            __props__.__dict__["profile"] = profile
            if services is None and not opts.urn:
                raise TypeError("Missing required property 'services'")
            __props__.__dict__["services"] = services
            __props__.__dict__["snippet"] = snippet
            __props__.__dict__["source_hips"] = source_hips
            if source_users is None and not opts.urn:
                raise TypeError("Missing required property 'source_users'")
            __props__.__dict__["source_users"] = source_users
            if sources is None and not opts.urn:
                raise TypeError("Missing required property 'sources'")
            __props__.__dict__["sources"] = sources
            __props__.__dict__["tags"] = tags
            if tos is None and not opts.urn:
                raise TypeError("Missing required property 'tos'")
            __props__.__dict__["tos"] = tos
            __props__.__dict__["type"] = type
            __props__.__dict__["tfid"] = None
        super(DecryptionRule, __self__).__init__(
            'scm:index/decryptionRule:DecryptionRule',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            action: Optional[pulumi.Input[str]] = None,
            categories: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            description: Optional[pulumi.Input[str]] = None,
            destination_hips: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            destinations: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            device: Optional[pulumi.Input[str]] = None,
            disabled: Optional[pulumi.Input[bool]] = None,
            folder: Optional[pulumi.Input[str]] = None,
            froms: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            log_fail: Optional[pulumi.Input[bool]] = None,
            log_setting: Optional[pulumi.Input[str]] = None,
            log_success: Optional[pulumi.Input[bool]] = None,
            name: Optional[pulumi.Input[str]] = None,
            negate_destination: Optional[pulumi.Input[bool]] = None,
            negate_source: Optional[pulumi.Input[bool]] = None,
            position: Optional[pulumi.Input[str]] = None,
            profile: Optional[pulumi.Input[str]] = None,
            services: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            snippet: Optional[pulumi.Input[str]] = None,
            source_hips: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            source_users: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            sources: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            tfid: Optional[pulumi.Input[str]] = None,
            tos: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            type: Optional[pulumi.Input[pulumi.InputType['DecryptionRuleTypeArgs']]] = None) -> 'DecryptionRule':
        """
        Get an existing DecryptionRule resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] action: The Action param. String must be one of these: `"decrypt"`, `"no-decrypt"`.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] categories: The Categories param.
        :param pulumi.Input[str] description: The Description param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] destination_hips: The DestinationHips param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] destinations: The Destinations param.
        :param pulumi.Input[str] device: The Device param.
        :param pulumi.Input[bool] disabled: The Disabled param.
        :param pulumi.Input[str] folder: The Folder param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] froms: The Froms param.
        :param pulumi.Input[bool] log_fail: The LogFail param.
        :param pulumi.Input[str] log_setting: The LogSetting param.
        :param pulumi.Input[bool] log_success: The LogSuccess param.
        :param pulumi.Input[str] name: The Name param.
        :param pulumi.Input[bool] negate_destination: The NegateDestination param.
        :param pulumi.Input[bool] negate_source: The NegateSource param.
        :param pulumi.Input[str] position: The Position param. String must be one of these: `"pre"`, `"post"`. Default: `"pre"`.
        :param pulumi.Input[str] profile: The Profile param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] services: The Services param.
        :param pulumi.Input[str] snippet: The Snippet param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] source_hips: The SourceHips param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] source_users: The SourceUsers param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] sources: The Sources param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] tags: The Tags param.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] tos: The Tos param.
        :param pulumi.Input[pulumi.InputType['DecryptionRuleTypeArgs']] type: The Type param.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _DecryptionRuleState.__new__(_DecryptionRuleState)

        __props__.__dict__["action"] = action
        __props__.__dict__["categories"] = categories
        __props__.__dict__["description"] = description
        __props__.__dict__["destination_hips"] = destination_hips
        __props__.__dict__["destinations"] = destinations
        __props__.__dict__["device"] = device
        __props__.__dict__["disabled"] = disabled
        __props__.__dict__["folder"] = folder
        __props__.__dict__["froms"] = froms
        __props__.__dict__["log_fail"] = log_fail
        __props__.__dict__["log_setting"] = log_setting
        __props__.__dict__["log_success"] = log_success
        __props__.__dict__["name"] = name
        __props__.__dict__["negate_destination"] = negate_destination
        __props__.__dict__["negate_source"] = negate_source
        __props__.__dict__["position"] = position
        __props__.__dict__["profile"] = profile
        __props__.__dict__["services"] = services
        __props__.__dict__["snippet"] = snippet
        __props__.__dict__["source_hips"] = source_hips
        __props__.__dict__["source_users"] = source_users
        __props__.__dict__["sources"] = sources
        __props__.__dict__["tags"] = tags
        __props__.__dict__["tfid"] = tfid
        __props__.__dict__["tos"] = tos
        __props__.__dict__["type"] = type
        return DecryptionRule(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def action(self) -> pulumi.Output[str]:
        """
        The Action param. String must be one of these: `"decrypt"`, `"no-decrypt"`.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter
    def categories(self) -> pulumi.Output[Sequence[str]]:
        """
        The Categories param.
        """
        return pulumi.get(self, "categories")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        The Description param.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="destinationHips")
    def destination_hips(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        The DestinationHips param.
        """
        return pulumi.get(self, "destination_hips")

    @property
    @pulumi.getter
    def destinations(self) -> pulumi.Output[Sequence[str]]:
        """
        The Destinations param.
        """
        return pulumi.get(self, "destinations")

    @property
    @pulumi.getter
    def device(self) -> pulumi.Output[Optional[str]]:
        """
        The Device param.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def disabled(self) -> pulumi.Output[Optional[bool]]:
        """
        The Disabled param.
        """
        return pulumi.get(self, "disabled")

    @property
    @pulumi.getter
    def folder(self) -> pulumi.Output[Optional[str]]:
        """
        The Folder param.
        """
        return pulumi.get(self, "folder")

    @property
    @pulumi.getter
    def froms(self) -> pulumi.Output[Sequence[str]]:
        """
        The Froms param.
        """
        return pulumi.get(self, "froms")

    @property
    @pulumi.getter(name="logFail")
    def log_fail(self) -> pulumi.Output[Optional[bool]]:
        """
        The LogFail param.
        """
        return pulumi.get(self, "log_fail")

    @property
    @pulumi.getter(name="logSetting")
    def log_setting(self) -> pulumi.Output[Optional[str]]:
        """
        The LogSetting param.
        """
        return pulumi.get(self, "log_setting")

    @property
    @pulumi.getter(name="logSuccess")
    def log_success(self) -> pulumi.Output[Optional[bool]]:
        """
        The LogSuccess param.
        """
        return pulumi.get(self, "log_success")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The Name param.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="negateDestination")
    def negate_destination(self) -> pulumi.Output[Optional[bool]]:
        """
        The NegateDestination param.
        """
        return pulumi.get(self, "negate_destination")

    @property
    @pulumi.getter(name="negateSource")
    def negate_source(self) -> pulumi.Output[Optional[bool]]:
        """
        The NegateSource param.
        """
        return pulumi.get(self, "negate_source")

    @property
    @pulumi.getter
    def position(self) -> pulumi.Output[str]:
        """
        The Position param. String must be one of these: `"pre"`, `"post"`. Default: `"pre"`.
        """
        return pulumi.get(self, "position")

    @property
    @pulumi.getter
    def profile(self) -> pulumi.Output[Optional[str]]:
        """
        The Profile param.
        """
        return pulumi.get(self, "profile")

    @property
    @pulumi.getter
    def services(self) -> pulumi.Output[Sequence[str]]:
        """
        The Services param.
        """
        return pulumi.get(self, "services")

    @property
    @pulumi.getter
    def snippet(self) -> pulumi.Output[Optional[str]]:
        """
        The Snippet param.
        """
        return pulumi.get(self, "snippet")

    @property
    @pulumi.getter(name="sourceHips")
    def source_hips(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        The SourceHips param.
        """
        return pulumi.get(self, "source_hips")

    @property
    @pulumi.getter(name="sourceUsers")
    def source_users(self) -> pulumi.Output[Sequence[str]]:
        """
        The SourceUsers param.
        """
        return pulumi.get(self, "source_users")

    @property
    @pulumi.getter
    def sources(self) -> pulumi.Output[Sequence[str]]:
        """
        The Sources param.
        """
        return pulumi.get(self, "sources")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        The Tags param.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def tfid(self) -> pulumi.Output[str]:
        return pulumi.get(self, "tfid")

    @property
    @pulumi.getter
    def tos(self) -> pulumi.Output[Sequence[str]]:
        """
        The Tos param.
        """
        return pulumi.get(self, "tos")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[Optional['outputs.DecryptionRuleType']]:
        """
        The Type param.
        """
        return pulumi.get(self, "type")

